import { ConfigLoader as CLD } from "./lib/config-process/config-loader";
import { EventsProcess as EP } from "./lib/events-process";
import { AgentConfig as CFG } from "./lib/config-process/config";
import { BackendProxy as BP } from "./lib/http/backend-proxy";
import { AgentEventsController as AEC } from "./lib/agent-events/agent-events-controller";
import { AgentType as AT, Technology as TEC } from "./lib/agent-events/agent-events-conracts";
import { EventTypes as ET, IEvent as IEVT } from "./lib/events-process/events-contracts";
import { ValidationUtils as VU } from "./lib/utils/validation-utils";
import { EventsCreator as EC } from "./lib/events-process/events-creator";
import { HttpClientConfigData as HCCD, IHttpClient as IHC, ContentType as CTP } from "./lib/http/contracts";
import { IWatchdog as IWD } from "./lib/watchdog";
import { IQueue as IQ } from "./lib/queue";
import { getSystemDateValueOf as GSD } from "./lib/system-date";
import { AgentInstanceData as AID } from "./lib/agent-instance-data";
import { ICollectionInterval as ICI } from "./lib/footprints-process/istanbul-to-footprints-contract";
import { CollectionInterval as CI } from "./lib/footprints-process/collection-interval";
import { IFootprintsFile as IFF, IFootprintsFile_Environment as IFFE, IFootprintsFile_Test as IFFT, IFootprintsFile_App as IFFA, IElement as IE, IAgentMeta as IAM, IFootprintsFile_App_File as IFFAF, IExecutionData as IED } from "./lib/contracts";
import { StateTracker as ST } from "./lib/state-tracker";
import { ConfigProcess as CP } from "./lib/config-process";
import { FootprintsProcess as FPPV6 } from "./lib/footprints-process-v6/index";
import { FootprintsBuffer as FPB } from "./lib/footprints-process-v6/footprints-buffer";
import { HitsCollector as HCL } from "./lib/footprints-process-v6/hits-collector";
import { HitsConverter as HCV } from "./lib/footprints-process-v6/hits-converter";
import { SourceMapData as SMD } from "./lib/footprints-process-v6/source-map-data";
import { RelativePathResolver as RPR } from "./lib/footprints-process-v6/relative-path-resolver";
import { IPosition as IPS, IIstanbulProcessMetrics as IIM } from "./lib/footprints-process-v6/contracts";
import { Watchdog as WD } from "./lib/watchdog";
import { CockpitNotifier as CN } from "./lib/agent-events/cockpit-notifier";
export declare namespace SlJsInfra {
    const AgentInstanceData: typeof AID;
    type AgentInstanceData = AID;
    type ConfigLoader = CLD;
    const ConfigLoader: typeof CLD;
    type EventsProcess = EP;
    const EventsProcess: typeof EP;
    type AgentConfig = CFG;
    const AgentConfig: typeof CFG;
    type BackendProxy = BP;
    const BackendProxy: typeof BP;
    type AgentEventsController = AEC;
    const AgentEventsController: typeof AEC;
    type EventsCreator = EC;
    const EventsCreator: typeof EC;
    type CollectionInterval = CI;
    const CollectionInterval: typeof CI;
    const getSystemDateValueOf: typeof GSD;
    type StateTracker = ST;
    const StateTracker: typeof ST;
    type ConfigProcess = CP;
    const ConfigProcess: typeof CP;
    type FootprintsBuffer = FPB;
    const FootprintsBuffer: typeof FPB;
    type HitsCollector = HCL;
    const HitsCollector: typeof HCL;
    type SourceMapData = SMD;
    const SourceMapData: typeof SMD;
    type HitsConverter = HCV;
    const HitsConverter: typeof HCV;
    type RelativePathResolver = RPR;
    const RelativePathResolver: typeof RPR;
    type FootprintsProcessV6 = FPPV6;
    const FootprintsProcessV6: typeof FPPV6;
    type Watchdog = WD;
    const Watchdog: typeof WD;
    type CockpitNotifier = CN;
    const CockpitNotifier: typeof CN;
    namespace Entities {
        type IHttpClient = IHC;
        type IEvent = IEVT;
        type IWatchdog = IWD;
        type IQueue = IQ<any>;
        type AgentType = AT;
        const AgentType: typeof AT;
        type Technology = TEC;
        const Technology: typeof TEC;
        type EventTypes = ET;
        const EventTypes: typeof ET;
        type HttpClientConfigData = HCCD;
        const HttpClientConfigData: typeof HCCD;
        type IFootprintsFile = IFF;
        type IFootprintsFile_Environment = IFFE;
        type IFootprintsFile_Test = IFFT;
        type IFootprintsFile_App = IFFA;
        type IElement = IE;
        type IAgentMeta = IAM;
        type IFootprintsFile_App_File = IFFAF;
        type ICollectionInterval = ICI;
        type IExecutionData = IED;
        type IPosition = IPS;
        type IIstanbulProcessMetrics = IIM;
        type ContentType = CTP;
        const ContentType: typeof CTP;
    }
    namespace Utils {
        type ValidationUtils = VU;
        const ValidationUtils: typeof VU;
    }
}
