import { AgentConfig } from "../config-process/config";
import { AgentEventCode, IAgentEvent, IAgentStartInfo, IPingData, ITagInfo, IToolInfo } from "./agent-events-conracts";
import { BackendProxy } from "../http/backend-proxy";
import { Watchdog } from "../watchdog";
import bunyan = require('bunyan');
import { AgentInstanceData } from "../agent-instance-data";
export declare class AgentEventsController {
    private static readonly PING_INTERVAL;
    private static readonly MAX_SHUTDOWN_RETRIES;
    private _agentConfig;
    private _agentInstanceData;
    private backendProxy;
    private _logger;
    private _sendsPing;
    private _pingWatchdog;
    private _tools;
    private startRequestStatus;
    private shutDownRetries;
    private submittedEventsMap;
    constructor(agentConfig: AgentConfig, agentInstanceData: AgentInstanceData, sendsPing: boolean, logger: bunyan, backendProxy?: BackendProxy, tool?: IToolInfo);
    submitAgentStartedEvent(packageJsonFile?: any): Promise<void>;
    private submitAgentEventRequest;
    buildAgentStartEvent(packageJsonFile: any): IAgentEvent<IAgentStartInfo>;
    buildAgentShutdownEvent(): IAgentEvent<IPingData>;
    submitAgentShutdownEvent(): Promise<boolean>;
    submitPingEvent(): void;
    submitEvent(code: AgentEventCode): void;
    submitEventOnce(code: AgentEventCode): void;
    submitGenericMessage(message: string): void;
    submitWarning(message: string): void;
    submitError(message: string): void;
    private sendMessage;
    submitConfigChanged(): void;
    readonly watchdog: Watchdog;
    readonly agentConfig: AgentConfig;
    readonly logger: bunyan;
    readonly sendsPing: boolean;
    readonly tools: IToolInfo[];
    resolveTags(): ITagInfo[];
    addTool(tollInfo: IToolInfo): void;
    private createBackendProxy;
    private initWatchdog;
    private getTimers;
    private buildEvent;
    readonly agentInstanceData: AgentInstanceData;
}
