import { AgentConfig } from "../config-process/config";
import { AgentInstanceData } from "../agent-instance-data";
import { BackendProxy } from "../http/backend-proxy";
import bunyan = require('bunyan');
import { IToolInfo, AgentEventCode } from "./agent-events-conracts";
/**
 * A class with static methods for sending notification to cockpit.
 * Using this class enables to avoid passing instance of AgentEventsController for each class
 */
export declare class CockpitNotifier {
    private static controller;
    private static controllerNullLogged;
    static notifyStart(agentConfig: AgentConfig, agentInstanceData: AgentInstanceData, sendsPing: boolean, logger: bunyan, packageJsonFile?: object, backendProxy?: BackendProxy, tool?: IToolInfo): Promise<void>;
    static notifyShutdown(): Promise<void>;
    static sendGenericMessage(message: string): void;
    static sendWarning(message: string): void;
    static sendError(message: string): void;
    static sendEvent(code: AgentEventCode): void;
    static sendEventOnce(code: AgentEventCode): void;
    private static logSkippedNotification;
    private static verifyControllerInitialized;
    static reset(): void;
}
