/// <reference types="node" />
import events = require("events");
import { Watchdog } from "../watchdog";
import bunyan = require('bunyan');
import { AgentConfig } from "./config";
import { BackendProxy } from "../http/backend-proxy";
export declare class ConfigProcess extends events.EventEmitter {
    private cfg;
    private watchdog;
    private backendProxy;
    private logger;
    private initialCfg;
    constructor(cfg: AgentConfig, watchdog: Watchdog, backendProxy: BackendProxy, logger: bunyan);
    private reloadConfigFromServer;
    private mergeConfigFromServerAndFireEvent;
    getConfiguration(): AgentConfig;
    private initCfg;
    private isRunning;
    start(callback?: (err: Error) => void): void;
    stop(callback: () => void): void;
}
