"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var parsing_utils_1 = require("../utils/parsing-utils");
var SlEnvVars = /** @class */ (function () {
    function SlEnvVars() {
    }
    SlEnvVars.getHttpTimeout = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.HTTP_TIMEOUT);
    };
    SlEnvVars.getHttpMaxAttempts = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.HTTP_MAX_ATTEMPTS);
    };
    SlEnvVars.getHttpAttemptInterval = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.HTTP_ATTEMPT_INTERVAL);
    };
    SlEnvVars.inProductionListenerMode = function () {
        return !!process.env[SlEnvVars.PRODUCTION_LISTENER];
    };
    SlEnvVars.getProductionListenerModes = function () {
        return (process.env[SlEnvVars.PRODUCTION_LISTENER] || "").split(',');
    };
    SlEnvVars.getFileStorage = function () {
        return process.env[SlEnvVars.FILE_STORAGE];
    };
    SlEnvVars.getBasePath = function () {
        return process.env[SlEnvVars.BASE_PATH];
    };
    SlEnvVars.isUseNewUniqueId = function () { return parsing_utils_1.ParsingUtils.parseBoolean(SlEnvVars.NEW_UNIQUE_ID); };
    SlEnvVars.isUseIstanbul = function () { return parsing_utils_1.ParsingUtils.parseBoolean(SlEnvVars.USE_ISTANBUL); };
    SlEnvVars.enableFootprintsV6 = function () {
        return parsing_utils_1.ParsingUtils.parseBoolean(SlEnvVars.ENABLE_FOOTPRINTS_V6);
    };
    SlEnvVars.getFootprintsCollectIntervalSecs = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.FOOTPRINTS_COLLECTION_INTERVAL_SECS);
    };
    SlEnvVars.getFootprintsSendMaxIntervalSecs = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.FOOTPRINTS_SEND_MAX_INTERVAL_SECS);
    };
    SlEnvVars.getFootprintsQueueSize = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.FOOTPRINTS_QUEUE_SIZE);
    };
    SlEnvVars.getExecutionQueryIntervalSecs = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.EXECUTION_QUERY_INTERVAL_SEC);
    };
    SlEnvVars.getFootprintsBufferThresholdMb = function () {
        return parsing_utils_1.ParsingUtils.parseNumber(SlEnvVars.FOOTPRINTS_BUFFER_THRESHOLD_MB);
    };
    var _a;
    //Controls the http timeout for all of the HTTP requests which
    //are being sent use the HttpClient.
    SlEnvVars.HTTP_TIMEOUT = "SL_httpTimeout";
    //For retriable endpoints, max number of attempts
    SlEnvVars.HTTP_MAX_ATTEMPTS = "SL_HttpMaxAttempts";
    //For retriable endpoints, sleep between attemps in mSec
    SlEnvVars.HTTP_ATTEMPT_INTERVAL = "SL_HttpAttemptInterval";
    //Set to 'true' in order to report production data.
    SlEnvVars.PRODUCTION_LISTENER = "SL_production";
    //Determines the path in which we store files.
    SlEnvVars.FILE_STORAGE = "SL_fileStorage";
    //Determines if should resolve with new uniqueId format.
    SlEnvVars.NEW_UNIQUE_ID = "SL_newUniqueId";
    //Determines the cwd
    SlEnvVars.BASE_PATH = "SL_basePath";
    SlEnvVars.USE_ISTANBUL = "SL_useIstanbul";
    SlEnvVars.ENABLE_FOOTPRINTS_V6 = "SL_footprintsEnableV6";
    SlEnvVars.FOOTPRINTS_COLLECTION_INTERVAL_SECS = "SL_footprintsCollectIntervalSecs";
    SlEnvVars.FOOTPRINTS_SEND_MAX_INTERVAL_SECS = "SL_footprintsSendIntervalSecs";
    SlEnvVars.FOOTPRINTS_QUEUE_SIZE = "SL_footprintsQueueSize";
    SlEnvVars.EXECUTION_QUERY_INTERVAL_SEC = "SL_executionQueryIntervalSecs";
    SlEnvVars.FOOTPRINTS_BUFFER_THRESHOLD_MB = "SL_footprintsBufferThresholdMb";
    SlEnvVars.CIA = (_a = /** @class */ (function () {
            function class_1() {
            }
            class_1.getFileExtensions = function () {
                return process.env[SlEnvVars.CIA.FILE_EXTENSIONS];
            };
            class_1.getSourceRoot = function () {
                return process.env[SlEnvVars.CIA.SL_SOURCE_ROOT];
            };
            class_1.getSlMappingPath = function () {
                return process.env[SlEnvVars.CIA.SL_MAPPING_PATH];
            };
            class_1.getSlMappingUrl = function () {
                return process.env[SlEnvVars.CIA.SL_MAPPING_URL];
            };
            return class_1;
        }()),
        //Allow to override the files extensions that will be scanned and instrumented by the Build Scanner.
        _a.FILE_EXTENSIONS = "SL_fileExtensions",
        //Determines the root path we should add to the source files.
        _a.SL_SOURCE_ROOT = "SL_sourceRoot",
        //Determine the physical path of sl-mapping file (relevant to cwd)
        _a.SL_MAPPING_PATH = "SL_mappingPath",
        //Determine the url of sl-mapping file (relevant application root)
        _a.SL_MAPPING_URL = "SL_mappingUrl",
        _a);
    return SlEnvVars;
}());
exports.SlEnvVars = SlEnvVars;
//# sourceMappingURL=sl-env-vars.js.map