/// <reference types="node" />
import { ICollectionInterval, IConvertedFootprints, IFootprintsV6File } from "./contracts";
import { AgentConfig } from "../config-process/config";
import { AgentInstanceData } from "../agent-instance-data";
import events = require("events");
/**
 * Holds the footprints hits data and builds the DTO for footprints packet
 */
export declare class FootprintsBuffer extends events.EventEmitter {
    static readonly BUFFER_FULL = "bufferFull";
    private formatVersion;
    private branches;
    private executions;
    private readonly meta;
    private methods;
    private moduleName;
    private agentInstanceData;
    private _agentConfig;
    private currentBufferSize;
    private methodIdToIndex;
    private branchIdToIndex;
    private bufferSizeHelper;
    constructor(agentInstanceData: AgentInstanceData, agentConfig: AgentConfig);
    addHit(footprints: IConvertedFootprints, collectionInterval: ICollectionInterval, executionId: string, testName: string, isInitFootprints: boolean, isFinalFootprints: boolean): void;
    createPacket(): IFootprintsV6File;
    resetState(): void;
    hasHitsInBuffer(): boolean;
    agentConfig: AgentConfig;
    private toJson;
    private addOrGetIndices;
    private addOrGetExecutionIndex;
    private verifyBufferSize;
}
