/**
 * Converts element hits to footprints (uniqueIds)
 */
import { IConvertedFootprints, IHitFileData, IPosition } from "./contracts";
import { RelativePathResolver } from "./relative-path-resolver";
import { SourceMapData } from "./source-map-data";
import bunyan = require('bunyan');
export declare class HitsConverter {
    static readonly METHOD_ID_DEL = "@";
    static readonly BRANCH_ID_DEL = "|";
    private relativePathResolver;
    private projectRoot;
    private sourceMapData;
    private logger;
    constructor(relativePathResolver: RelativePathResolver, sourceMapData: SourceMapData, projectRoot: string, logger: bunyan);
    convertHits(hitFilesData: IHitFileData[]): IConvertedFootprints;
    private createMethodIds;
    private createBranchIds;
    protected getMethodUniqueId(startLoc: IPosition, relativePath: string, absolutePath: string): string;
    protected getBranchUniqueId(startLoc: IPosition, relativePath: string, absolutePath: string, leaveIndex: number): string;
    private resolveIdParts;
    private buildMethodUniqueId;
    protected formatLoc(loc: IPosition): string;
}
