import { AgentConfig } from "../config-process/config";
import { Watchdog } from "../watchdog";
import { HitsCollector } from "./hits-collector";
import { HitsConverter } from "./hits-converter";
import { FootprintsBuffer } from "./footprints-buffer";
import bunyan = require('bunyan');
import { StateTracker } from "../state-tracker";
import { BackendProxy } from "../http/backend-proxy";
export declare class FootprintsProcess {
    private static readonly ALARM_FIRED;
    private cfg;
    private sendToServerWatchdog;
    private keepaliveWatchdog;
    private hitsCollector;
    private hitsConverter;
    private footprintsBuffer;
    private collectionInterval;
    private currentExecutionBsid;
    private isRunning;
    private stateTracker;
    private logger;
    private backendProxy;
    private ongoingRequestsCounter;
    private footprintsEnqueueOnce;
    constructor(cfg: AgentConfig, sendToServerWatchdog: Watchdog, keepaliveWatchdog: Watchdog, logger: bunyan, hitsCollector: HitsCollector, hitsConverter: HitsConverter, footprintsBuffer: FootprintsBuffer, backendProxy: BackendProxy, stateTracker: StateTracker);
    enqueueCurrentFootprints(executionId: string, testName: string, executionBsid: string, isFinalFootprints?: boolean): void;
    updateConfig(updatedCfg: AgentConfig): void;
    private ensureKeepaliveThreadRunning;
    submitQueuedFootprints(): Promise<void>;
    private shouldSubmitFootprints;
    start(): void;
    stop(callback: () => void): void;
    handleTestIdChanged(newTestIdentifier: any, previousTestIdentifier: any): void;
    delegateEvents(): void;
    private enqueueAndSubmit;
    flushCurrentFootprints(isFinalFootprints?: boolean): void;
    private handleNoExecutionFound;
    private isInitFootprints;
    hasOngoingRequests(): boolean;
}
