"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RelativePathResolver = /** @class */ (function () {
    function RelativePathResolver(projectRoot) {
        this.absoluteToRelativePath = new Map();
        this.projectRoot = projectRoot;
    }
    RelativePathResolver.prototype.getRelativePath = function (absolutePath) {
        if (!this.absoluteToRelativePath.get(absolutePath)) {
            absolutePath = this.adjustPathSlashes(absolutePath);
            var relativePath = absolutePath.replace(this.resolveProjectRoot(), "");
            if (relativePath.indexOf("/") === 0) {
                relativePath = relativePath.substring(1);
            }
            this.absoluteToRelativePath.set(absolutePath, relativePath);
        }
        return this.absoluteToRelativePath.get(absolutePath);
    };
    RelativePathResolver.prototype.adjustPathSlashes = function (filePath) {
        return (filePath || "").replace(/\\/g, '/');
    };
    RelativePathResolver.prototype.resolveProjectRoot = function () {
        return (this.projectRoot || process.cwd()).replace(/\\/g, '/');
    };
    return RelativePathResolver;
}());
exports.RelativePathResolver = RelativePathResolver;
//# sourceMappingURL=relative-path-resolver.js.map