/// <reference types="node" />
import bunyan = require("bunyan");
import events = require("events");
import { Watchdog } from "./watchdog";
import { AgentConfig } from "./config-process/config";
import { ConfigProcess } from "./config-process";
import { BackendProxy } from "./http/backend-proxy";
import { IExecutionData } from "./contracts";
export declare class StateTracker extends events.EventEmitter {
    static readonly EXECUTION_ENDS = "executionEnds";
    static readonly EXECUTION_BSID_CHANGED = "executionBsidChanged";
    static readonly EXECUTION_ID_CHANGED = "executionIdChanged";
    static readonly TEST_STAGE_CHANGED = "testStageChanged";
    static readonly EXECUTION_STATUS_CREATED = "created";
    static readonly EXECUTION_STATUS_PENDING_DELETE = "pendingDelete";
    private cfg;
    private configProcess;
    private checkTestStatusWatchdog;
    private backendProxy;
    private logger;
    private currentTestIdentifier;
    private _currentExecution;
    private isRunning;
    private _openExecutionFoundOnce;
    private endingExecutionFoundOnce;
    constructor(cfg: AgentConfig, configProcess: ConfigProcess, checkTestStatusWatchdog: Watchdog, backendProxy: BackendProxy, logger: bunyan);
    private startCheckingTestStatusAtServer;
    private checkTestStatusAtServer;
    private getExecutionIdForQuery;
    hasMappingAtServer(): boolean;
    shouldCollectHits(): boolean;
    currentExecution: IExecutionData;
    readonly openExecutionFoundOnce: boolean;
    isAnonymousColor(testIdentifier: string): boolean;
    private switchToAnonFootprints;
    getCurrentTestIdentifier(): string;
    setTestIdentifier(newTestIdentifier: string, silent?: boolean): void;
    setCurrentTestIdentifier(newTestIdentifier: string | null): void;
    start(): void;
    stop(callback: () => void): void;
    getTestStage(): string;
    static splitTestIdToExecutionAndTestName(testId: string): {
        executionId: string;
        testName: string;
    };
    static combineExecutionIdAndTestName(executionId: any, testName: any): string;
    startColoredExecution(executionId: string): Promise<void>;
    private fireExecutionEvents;
    private notifyCockpit;
}
