"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var events = require("events");
var timers_1 = require("timers");
var sl_env_vars_1 = require("./constants/sl-env-vars");
var validation_utils_1 = require("./utils/validation-utils");
var cockpit_notifier_1 = require("./agent-events/cockpit-notifier");
var agent_events_conracts_1 = require("./agent-events/agent-events-conracts");
var INITIAL_COLOR = "00000000-0000-0000-0000-000000000000/__init";
var StateTracker = /** @class */ (function (_super) {
    __extends(StateTracker, _super);
    function StateTracker(cfg, configProcess, checkTestStatusWatchdog, backendProxy, logger) {
        var _this = _super.call(this) || this;
        _this.currentTestIdentifier = null;
        _this.isRunning = false;
        _this._openExecutionFoundOnce = false;
        _this.endingExecutionFoundOnce = false;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(cfg, "agentConfig");
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(configProcess, "configProcess");
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(checkTestStatusWatchdog, "watchdog");
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(backendProxy, "backendProxy");
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(logger, "logger");
        _this.cfg = cfg;
        _this.configProcess = configProcess;
        _this.checkTestStatusWatchdog = checkTestStatusWatchdog;
        _this.backendProxy = backendProxy;
        _this.logger = logger;
        if (_this.cfg.useInitialColor.value && _this.currentTestIdentifier == null) {
            _this.switchToAnonFootprints();
        }
        configProcess.on("configuration_changed", function (newCfg) {
            if (newCfg.useInitialColor.value && _this.currentTestIdentifier == null) {
                _this.switchToAnonFootprints();
            }
            _this.cfg = newCfg;
            _this.checkTestStatusWatchdog.setInterval(newCfg.executionQueryIntervalSecs.value);
        });
        _this.startCheckingTestStatusAtServer();
        return _this;
    }
    StateTracker.prototype.startCheckingTestStatusAtServer = function () {
        var _this = this;
        if (sl_env_vars_1.SlEnvVars.inProductionListenerMode()) {
            this.logger.debug("In production listener, no need to check test status in server");
            return;
        }
        this.checkTestStatusWatchdog.on("alarm", function () {
            _this.checkTestStatusAtServer();
        });
        //Invoke it directly after the CTOR ends.
        timers_1.setTimeout(function () {
            _this.checkTestStatusAtServer(false);
        }, 0);
    };
    StateTracker.prototype.checkTestStatusAtServer = function (async) {
        var _this = this;
        if (async === void 0) { async = true; }
        if (!this.currentTestIdentifier) {
            this.logger.info("'currentTestIdentifier' is null. That means that footprints will not be sent.");
        }
        else {
            this.backendProxy.testExecutionV4(this.cfg.labId.value, async, this.getExecutionIdForQuery()).then(function (response) {
                _this.fireExecutionEvents(response.execution);
                _this.notifyCockpit(response.execution);
                _this._currentExecution = response.execution;
            }).catch(function (err) {
                _this.logger.warn("Error while checking test execution status " + err);
            });
        }
    };
    StateTracker.prototype.getExecutionIdForQuery = function () {
        if (this.isAnonymousColor(this.currentTestIdentifier) || !this.currentExecution) {
            return null;
        }
        return this.currentExecution.executionId;
    };
    StateTracker.prototype.hasMappingAtServer = function () {
        return this._currentExecution != null;
    };
    StateTracker.prototype.shouldCollectHits = function () {
        return this.hasMappingAtServer() && this.currentExecution.status != StateTracker.EXECUTION_STATUS_PENDING_DELETE;
    };
    Object.defineProperty(StateTracker.prototype, "currentExecution", {
        get: function () {
            return this._currentExecution;
        },
        set: function (value) {
            this._currentExecution = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StateTracker.prototype, "openExecutionFoundOnce", {
        get: function () {
            return this._openExecutionFoundOnce;
        },
        enumerable: true,
        configurable: true
    });
    StateTracker.prototype.isAnonymousColor = function (testIdentifier) {
        return INITIAL_COLOR == testIdentifier;
    };
    StateTracker.prototype.switchToAnonFootprints = function () {
        this.logger.info("Switching to anonymous footprints.");
        this.setTestIdentifier(INITIAL_COLOR, false);
    };
    StateTracker.prototype.getCurrentTestIdentifier = function () {
        return this.currentTestIdentifier;
    };
    StateTracker.prototype.setTestIdentifier = function (newTestIdentifier, silent) {
        this.logger.info("setting test identifier: " + newTestIdentifier);
        if ((this.currentTestIdentifier == null) && (newTestIdentifier != null) || (this.currentTestIdentifier != null && this.currentTestIdentifier != newTestIdentifier && newTestIdentifier != INITIAL_COLOR)) {
            var previousTestIdentifier = this.currentTestIdentifier;
            this.currentTestIdentifier = newTestIdentifier;
            if (this.isRunning) {
                if (!silent) {
                    this.emit("test_identifier_changed", this.currentTestIdentifier, previousTestIdentifier);
                }
                else {
                    this.logger.info("Test identifier changed, running in silent mode not enqueuing footprints");
                }
                this.checkTestStatusWatchdog.reset();
            }
        }
        else {
            this.logger.info("Not setting the color. newTestIdentifier is '" + newTestIdentifier + "' " + "and currentTestIdentifier is '" + this.currentTestIdentifier + "'");
        }
    };
    // Added for backward compatibility with browser agent
    StateTracker.prototype.setCurrentTestIdentifier = function (newTestIdentifier) {
        this.setTestIdentifier(newTestIdentifier);
    };
    StateTracker.prototype.start = function () {
        if (!this.isRunning) {
            this.checkTestStatusWatchdog.start();
            this.isRunning = true;
        }
    };
    StateTracker.prototype.stop = function (callback) {
        try {
            if (!this.isRunning) {
                return callback();
            }
            this.checkTestStatusWatchdog.stop();
            this.isRunning = false;
            callback();
        }
        catch (err) {
            this.logger.error("Error while stopping StateTracker. '" + err + "'");
            return callback();
        }
    };
    StateTracker.prototype.getTestStage = function () {
        return (this.currentExecution && this.currentExecution.testStage) || this.cfg.testStage.value;
    };
    StateTracker.splitTestIdToExecutionAndTestName = function (testId) {
        testId = testId || '';
        var executionId = testId.split('/')[0];
        var testName = (testId.indexOf('/') == -1) ? "" : testId.substring(executionId.length + 1);
        if (!executionId) {
            testName = "";
        }
        return { executionId: executionId, testName: testName };
    };
    StateTracker.combineExecutionIdAndTestName = function (executionId, testName) {
        testName = testName || '';
        if (!executionId) {
            return '';
        }
        return executionId + '/' + testName;
    };
    StateTracker.prototype.startColoredExecution = function (executionId) {
        return __awaiter(this, void 0, void 0, function () {
            var request, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        request = {
                            appName: this.cfg.appName.value,
                            branchName: this.cfg.branch.value,
                            buildName: this.cfg.build.value,
                            labId: this.cfg.labId.value,
                            testStage: this.cfg.testStage.value,
                            executionId: executionId,
                        };
                        return [4 /*yield*/, this.backendProxy.startColoredExecution(request)];
                    case 1:
                        _a.sent();
                        this.currentExecution = __assign({}, request, { buildSessionId: this.cfg.buildSessionId.value, status: StateTracker.EXECUTION_STATUS_CREATED });
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        this.logger.error("Failed to create execution, error '" + e_1 + "'. Footprints will not be sent");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    StateTracker.prototype.fireExecutionEvents = function (executionData) {
        // No active execution on the server
        if (!executionData) {
            return;
        }
        if (executionData.status == StateTracker.EXECUTION_STATUS_PENDING_DELETE && !this.endingExecutionFoundOnce) {
            this.emit(StateTracker.EXECUTION_ENDS, executionData);
            this.endingExecutionFoundOnce = true;
            return;
        }
        // First time got response from server
        if (!this.currentExecution) {
            return;
        }
        if (this.currentExecution.buildSessionId != executionData.buildSessionId) {
            this.emit(StateTracker.EXECUTION_BSID_CHANGED, this.currentExecution, executionData.buildSessionId);
            return;
        }
        if (this.currentExecution.executionId != executionData.executionId) {
            this.emit(StateTracker.EXECUTION_ID_CHANGED, this.currentExecution, executionData.buildSessionId);
            return;
        }
        if (this.currentExecution.testStage != executionData.testStage) {
            this.emit(StateTracker.TEST_STAGE_CHANGED, this.currentExecution, executionData.testStage);
            return;
        }
        if (executionData.status !== StateTracker.EXECUTION_STATUS_PENDING_DELETE) {
            this.endingExecutionFoundOnce = false;
        }
    };
    StateTracker.prototype.notifyCockpit = function (execution) {
        if (!execution) {
            cockpit_notifier_1.CockpitNotifier.sendEventOnce(agent_events_conracts_1.AgentEventCode.FIRST_TIME_NO_EXECUTION);
        }
        else {
            cockpit_notifier_1.CockpitNotifier.sendEventOnce(agent_events_conracts_1.AgentEventCode.FIRST_TIME_HAS_EXECUTION);
            this._openExecutionFoundOnce = true;
        }
    };
    StateTracker.EXECUTION_ENDS = "executionEnds";
    StateTracker.EXECUTION_BSID_CHANGED = "executionBsidChanged";
    StateTracker.EXECUTION_ID_CHANGED = "executionIdChanged";
    StateTracker.TEST_STAGE_CHANGED = "testStageChanged";
    StateTracker.EXECUTION_STATUS_CREATED = "created";
    StateTracker.EXECUTION_STATUS_PENDING_DELETE = "pendingDelete";
    return StateTracker;
}(events.EventEmitter));
exports.StateTracker = StateTracker;
//# sourceMappingURL=state-tracker.js.map