export interface IBuildSessionParams {
    appName: string;
    buildName: string;
    branchName: string;
    customerId: string;
}
export interface IArgumentsObject {
    projectRoot: IProjectArgument;
}
export interface IProjectArgument {
    scanner: string;
    listener: string;
}
export interface IEvent {
    type: string;
    name: string;
}
export interface IEventResponse {
    events: IEvent[] | ITestEvent[];
}
export interface ITestsRecommendationResponse {
    excludedTests: IExcludedTest[];
    recommendationSetStatus: string;
    testSelectionEnabled: boolean;
    statusForRetries?: number;
    retriesNumber?: number;
    status: number;
}
export interface IExcludedTest {
    name: string;
    test_id: string;
    testFramework: string;
}
export interface ITestEvent {
    type: string;
    testName: string;
    executionId: string;
    testPath: string[];
    meta: object;
    localTime: number;
}
export interface ITestEndEvent extends ITestEvent {
    result: string;
}
export interface IRetryCounters {
    excludedTests: number;
}
export interface ISourceMapMessage {
    sources: string[];
    hasColumnInfo: boolean;
    generatedFileName: string;
}
export declare enum HttpVerb {
    GET = "GET",
    POST = "POST",
    DELETE = "DELETE",
    PUT = "PUT"
}
export interface ISettings {
    status: number;
    requestsBeforeStatusExpires: number;
    requestIndex?: number;
}
export interface IRoute {
    method: HttpVerb;
    settings: ISettings;
    url: string;
}
export interface IAgentEvent {
    type: number;
    utcTimestamp_ms: number;
    data: string;
}
export interface IAgentEventsRequest {
    appName: string;
    agentId: string;
    buildSessionId: string;
    events: IAgentEvent[];
}
export interface ISourceMapMessageExpectation {
    eventsNo: number;
    hasColumnInfo: boolean;
    eventType: number;
}
export interface IBuildEndData {
    appName: string;
    build: string;
    branch: string;
    status: IBuildEndStatus;
}
export interface IBuildEndStatus {
    success: boolean;
    message?: string;
    duration?: number;
}
