"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var contracts_1 = require("./contracts");
/**
 * A proxy for interacting sealights mock server using promises
 */
var MockServerProxy = /** @class */ (function () {
    function MockServerProxy() {
    }
    MockServerProxy.getAllFootprints = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeSlRequest(this.GET_ALL_FOOTPRINTS, contracts_1.HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.setRecommendedVersion = function (requestParams) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.SET_RECOMMENDED_VERSION, contracts_1.HttpVerb.POST, null, requestParams)];
            });
        });
    };
    MockServerProxy.createBuildSessionId = function (buildSessionParams) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.CREATE_BUILDSESSION_ID, contracts_1.HttpVerb.POST, false, buildSessionParams)];
            });
        });
    };
    MockServerProxy.getBuildMapping = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeSlRequest(this.GET_BUILD_MAPPING, contracts_1.HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.resetState = function () {
        return this.executeSlRequest(this.RESET, contracts_1.HttpVerb.GET, false);
    };
    MockServerProxy.getToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_TOKEN, contracts_1.HttpVerb.GET, false)];
            });
        });
    };
    MockServerProxy.setActiveBSID = function (buildSessionId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.SET_ACTIVE_BSID + "/" + buildSessionId, contracts_1.HttpVerb.POST, false)];
            });
        });
    };
    MockServerProxy.getTestEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_TEST_EVENTS, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.setTestExclusions = function (buildSessionId, testStage, testRecommendations) {
        return __awaiter(this, void 0, void 0, function () {
            var uri;
            return __generator(this, function (_a) {
                uri = this.SET_TEST_EXCLUSIONS + "/" + buildSessionId + "/" + testStage;
                return [2 /*return*/, this.executeSlRequest(uri, contracts_1.HttpVerb.POST, false, testRecommendations)];
            });
        });
    };
    MockServerProxy.getRetryCounters = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_RETRY_COUNTERS, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.getAgentEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_AGENT_EVENTS, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.getBuildEndStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_BUILD_END, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.getLogs = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.GET_LOGS, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.setDelay = function (duration_ms, requestToBeDelayed) {
        var requestData = { duration_ms: duration_ms, requestToBeDelayed: requestToBeDelayed };
        return this.executeRequest(MockServerProxy.SET_DELAY, contracts_1.HttpVerb.POST, null, requestData);
    };
    MockServerProxy.setEnabled = function (enabled) {
        var requestData = { enabled: enabled };
        return this.executeRequest(MockServerProxy.SET_ENABLED, contracts_1.HttpVerb.POST, null, requestData);
    };
    MockServerProxy.setRouteSettings = function (url, verb, status, requestsBeforeStatusExpires) {
        return __awaiter(this, void 0, void 0, function () {
            var request;
            return __generator(this, function (_a) {
                request = {
                    url: url,
                    method: verb,
                    settings: {
                        requestsBeforeStatusExpires: requestsBeforeStatusExpires,
                        status: status
                    }
                };
                return [2 /*return*/, this.executeSlRequest(this.SETTINGS, contracts_1.HttpVerb.PUT, false, [request])];
            });
        });
    };
    MockServerProxy.setTestExecution = function (execution) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.SET_TEST_EXECUTION, contracts_1.HttpVerb.POST, false, { execution: execution })];
            });
        });
    };
    MockServerProxy.getSettings = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeSlRequest(this.SETTINGS, contracts_1.HttpVerb.GET)];
            });
        });
    };
    MockServerProxy.executeSlRequest = function (uri, verb, shouldParse, requestData) {
        if (shouldParse === void 0) { shouldParse = true; }
        return this.executeRequest(this.SERVER_URL + uri, verb, shouldParse, requestData);
    };
    MockServerProxy.executeRequest = function (url, verb, shouldParse, requestData) {
        if (shouldParse === void 0) { shouldParse = true; }
        return new Promise(function (resolve, reject) {
            var options = {
                url: url,
                method: verb,
                headers: {
                    "content-type": "application/json",
                },
                json: requestData
            };
            request(options, function (err, resp, body) {
                if (err) {
                    reject(err);
                }
                if (resp.statusCode > 299) {
                    reject(new Error("Unexpected status code received: " + resp.statusCode));
                }
                if (shouldParse) {
                    try {
                        var parsedResponse = JSON.parse(body);
                        resolve(parsedResponse);
                    }
                    catch (err) {
                        reject(err);
                    }
                }
                resolve(body);
            });
        });
    };
    //TODO: extract to external 'routes' file
    MockServerProxy.SERVER_URL = "http://localhost:9900";
    MockServerProxy.GET_ALL_FOOTPRINTS = "/api/test/footprints";
    MockServerProxy.GET_BUILD_MAPPING = "/api/test/buildmapping";
    MockServerProxy.RESET = "/api/test/reset";
    MockServerProxy.GET_TOKEN = "/api/test/token";
    MockServerProxy.CREATE_BUILDSESSION_ID = "/api/v2/agents/buildsession";
    MockServerProxy.SET_RECOMMENDED_VERSION = "/api/test/recommended";
    MockServerProxy.SET_ACTIVE_BSID = "/api/test/lab-ids/build-sessions/active";
    MockServerProxy.GET_TEST_EVENTS = "/api/test/agents/events";
    MockServerProxy.SET_TEST_EXCLUSIONS = "/api/test/test-exclusions";
    MockServerProxy.GET_RETRY_COUNTERS = "/api/test/retry-counters";
    MockServerProxy.GET_AGENT_EVENTS = "/api/test/v3/agents/agent-events";
    MockServerProxy.SETTINGS = "/settings";
    MockServerProxy.TEST_EXCLUSION = "/api/v2/test-exclusions/:buildSessionId/:testStage";
    MockServerProxy.GET_BUILD_END = '/api/test/buildend';
    MockServerProxy.GET_LOGS = '/api/test/logs';
    MockServerProxy.SET_DELAY = "/api/test/setDelay";
    MockServerProxy.SET_ENABLED = "/api/test/setEnabled";
    MockServerProxy.SET_BUILD_END = '/api/v3/agents/buildend';
    MockServerProxy.SET_TEST_EXECUTION = '/api/test/testExecution';
    MockServerProxy.FOOTPRINTS_V6 = '/api/v6/agents/:executionBsId/footprints/:testStage/:buildSessionId';
    return MockServerProxy;
}());
exports.MockServerProxy = MockServerProxy;
//# sourceMappingURL=mock-server-proxy.js.map